----------------------------------------------------------------------
----------
0. Introduction
----------
Included are sample C++ codes of the procedures described in

	K. Kanatani, Y. Sugaya, and Y. Kanazawa,
	Guide to 3D Vision Computation,
	Springer, 2016,
	ISBN: 978-4-627-81791-3 (ebook),
	ISBM: 978-3-319-48492-1 (hardcover).

Note: Our codes are created from scratch.  Hence, they are not of the
form when the related papers were published.  The codes were tested
with particular set of data, so they may still include some hidden
bugs.

----------
1. Required
----------
Our programs require the following libraries:

	Eigen3
	OpenCV 2.4.X

Before compiling our programs, please install these libraries.

Note: OpenCV is only used for displaying and manipulating images.  If
you only want mathematical results shown in the book, you need not
install OpenCV.

----------
2. Check Environment
----------
We tested our programs on the following environment:

	Debian GNU/Linux 8.6 (Jessie)
	Eigen3 (eigen-eigen-bdd17ee3b1b3)
	OpenCV (2.4.9)
	C++ (gcc version 4.9.2 (Debian 4.9.2-10))

----------
3. Directories
----------
The following directories are included:

	``srcs''  includes the source files of the procedures.
	``check'' includes check programs.

----------
4. Compile
----------
The programs in each chapter are almost independent, and the necessary
libraries are built in each ``srcs'' directory.  So, you can compile the
programs for each chapter separately.

In each chapter, we have prepared very simple Makefiles, so, you can
just hit

	$ make


Note: Some procedures depend on the library in the directory of other
chapters.  Please check Makefile(s).

Most check programs are in 

	check/main

They read sample data and outputs the result(s).  The output file with
extension ``ply'' is a 3-D data file with PLY format.  It can be
displayed using a PLY viewer like Meshlab.  For using Meshlab, please
visit the following url:

	http://meshlab.sourceforge.net

----------
5. Correspondences between procedures and programs
----------
Please check README.md in each chapter directory.

----------
6. Use and License
----------
All the codes are created to illustrate implementation examples of the
procedures described in the book.  Hence, they may not be necessarily
be optimal in efficiency, and further speed-up may be possible by
using suitable libraries.  For actual application, you are advised to
add suitable modifications.

For non-commercial use, you can use and modify these codes freely.
In case you want to use them for for commercial products, please
contact the authors.

----------
7. Acknowledgments
----------

We thank Takuji Nishimura and Makoto Matsumoto for their Mersenne
Twister, a well-known algorithm for generating random numbers:

	M. Matsumoto and T. Nishimura,
	Mersenne twister: A 623-dimensionally equidistributed uniform
	pseudorandom number generator,
	ACM Transactions on Modeling and Computer Simulations, 1998.

Their code can be obtained from

	http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/mt.html

We also thank Mizuki Hashimoto and Ryotaro Matsunaga, master course
students of Toyohashi University of Technology, Japan, who helped us
write and test our codes.

----------
8. Version
----------
	Version 0.3:	June 27, 2017.
	Version 0.2:	Dec. 16, 2016.
	Version 0.1.1:	Oct. 25, 2016.
	Version 0.1:	Oct. 24, 2016.

----------
9. Contact
----------
If you find any problems, please contact to

	kanazawa@cs.tut.ac.jp
		or
	sugaya@cs.tut.ac.jp

----------------------------------------------------------------------
