----------------------------------------------------------------------
----------
0. はじめに
----------
本プログラムは

	金谷 健一，菅谷 保之，金澤 靖，
	３次元コンピュータビジョン計算ハンドブック，
	森北出版，2016.10.27
	ISBN: 978-4-627-81791-3

における各手順のC++によるプログラム例です．

これらのプログラムは，元の論文発表当時そのままのプログラムではなく，一
から書き直しています．いくつかのデータでの確認をしておりますが，バグ等
の問題を含んでいる可能性がありますので，ご承知おき下さい．

----------
1. 必要なもの
----------
本プログラムは，次のライブラリを必要としています．

	Eigen3
	OpenCV 2.4.X

本プログラムをコンパイルする前に，これらをインストールして下さい．

ただし，OpenCV は画像の読み書きや表示のためだけに使っています．したがっ
て，これらを使わない場合，インストールする必要はありません．

----------
2. 確認環境
----------
以下の環境で動作を確認しています．

	Debian GNU/Linux 8.3 (Jessie)
	Eigen3 (eigen-eigen-bdd17ee3b1b3)
	OpenCV (2.4.9)
	C++ (gcc version 4.9.2 (Debian 4.9.2-10))

----------
3. ディレクトリ構成
----------
各章のディレクトリの構成は以下の通りです．

	srcs:  各手順のヘッダファイルおよびソース
	check: 動作チェック用の簡単なプログラム

----------
4. コンパイルと実行
----------
各章のソースはほぼ独立しており，ほぼ各章毎にコンパイル可能です．またラ
イブラリも各章毎に作成されます．

コンパイルのために，極めて単純な Makefile のみを用意してあります．した
がって，多くの場合，次のようにすればコンパイル可能です．

	$ make

ライブラリは srcs に置かれます．必要に応じて，Makefileを修正して下さい．

チェック用実行プログラムは，ほぼ

	check/main

です．サンプルデータを読み込み，結果を出力します．なお，3次元復元結果
などで拡張子が ply となっているファイルは Meshlab 等のプログラムで3次
元表示が可能です．Meshlabについては

	http://meshlab.sourceforge.net

にありますので，別途ご用意下さい．

----------
5. 各手順との対応について
----------
どのファイルがどの手順に相当するかは，各章のREADME.jpを参考にして下さ
い．

----------
6. 本プログラムに利用について
----------
これらのプログラムは，あくまで各手順の実装例を示したもので，本書内での
効率化は考慮しておりますが，それ以外，例えば他のライブラリ利用による効
率化等は全く考慮していないため，実際の利用には多少の修正が必要になると
思います．非商用利用においては，自由に改変してご利用していただいて構い
ませんが，商用利用の場合は，著者らにご連絡下さい．

----------
*. 謝辞
----------
乱数発生のプログラムは

	M. Matsumoto and T. Nishimura,
	Mersenne twister: A 623-dimensionally equidistributed uniform
	pseudorandom number generator,
	ACM Trans. on Modeling and Computer Simulations, 1998.

に基づき公開されている Nishimura氏とMatsumoto氏のメルセンヌツイスタの
プログラム

	http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/mt.html

を使わせていただいております．この場を借りて，お礼申し上げます．

また，本プログラム作成を手伝って頂いた豊橋技術科学大学大学院 博士前期
課程1年の橋本瑞樹君，松永竜太郎君に感謝いたします．

----------
**. バージョン
----------
	Version 0.3:	June 27, 2017.
	Version 0.2:	Dec. 16, 2016.
	Version 0.1.1:	Oct. 25, 2016.
	Version 0.1:	Oct. 24, 2016.

----------
***. 連絡先
----------
バグ等，何か問題がございましたら，下記宛に連絡いただけると幸甚です．

	kanazawa@cs.tut.ac.jp
		or
	sugaya@cs.tut.ac.jp

----------------------------------------------------------------------
