#ifndef _UTILS_H_
#define _UTILS_H_

#include <Eigen/Dense>

using namespace Eigen;

bool
read_data_files(const char filetemplate[],
                int CamNum,
                MatrixXd **pt0,
                int *PtNum);

bool
read_data(const char filename[],
          MatrixXd **pt0,
          int *CamNum,
          int *PtNum);

bool
write_data(const char filename[],
           const Vector4d X[],
           int PtNum);

bool
write_3d_data(const char filename[],
              const Vector3d X[],
              int PtNum);
   
bool
write_4d_data(const char filename[],
              const Vector4d X[],
              int PtNum);

bool
write_proj_files(const char filetemplate[],
                 const Matrix34d Proj[],
                 int CamNum);

bool
write_ply_data(const char filename[],
               const Vector4d X[],
               int PtNum,
               int r, int g, int b);

bool
write_3d_ply_data(const char filename[],
                  const Vector3d X[],
                  int PtNum,
                  int r, int g, int b);
   
#endif // _UTILS_H_
