//
// test function for ellipse fitting
//

#include <iostream>
#include <iomanip>
#include <string>

#include "EllipseFitting.h"
#include "utils.h"

using namespace Eigen;
using namespace std;

int main()
{
   double *x, *y;
   int Num;
   char filename[] = "sim.dat";

   // read data
   if (!read_data(filename, &x, &y, &Num))
      return 1;

   // convert data
   Vector2d pos[Num];
   for (int al = 0; al < Num; al++)
      pos[al] << x[al], y[al];

   // compute ellipse parameters
   Vector6d theta;
   
   // EllipseFitting::least_squares(pos, Num, theta);
   // EllipseFitting::iterative_reweight(pos, Num, theta);
   // EllipseFitting::taubin(pos, Num, theta);
   // EllipseFitting::renormalization(pos, Num, theta);
   // EllipseFitting::hyper_least_squares(pos, Num, theta);
   // EllipseFitting::hyper_renormalization(pos, Num, theta);
   // EllipseFitting::fns(pos, Num, theta);
   // EllipseFitting::geometric_distance_minimization(pos, Num, theta);
   // EllipseFitting::hyperaccurate_correction(pos, Num, theta);
   // EllipseFitting::fitzgibbon(pos, Num, theta);
   // EllipseFitting::random_sampling(pos, Num, theta);
   EllipseFitting::ransac(pos, Num, theta);

   cout << scientific << setprecision(10)
        << "Parameters = \n" << theta << endl;

   return 0;
}
