//
// test function for Triangulation
//

#include <iostream>
#include <iomanip>
#include <string>

#include "Triangulation.h"
#include "utils.h"

using namespace Eigen;
using namespace std;

int main()
{
   Vector2d     *pos0, *pos1,*npos0, *npos1;
   Matrix3d     F;
   Vector9d     theta;
   int          Num1, Num2, Num;
   bool         flag;
   char         Fname[] = "F.dat";
//   char         infile1[] = "data1.dat";
//   char         infile2[] = "data2.dat";
   char         infile1[] = "noise-s1.dat";
   char         infile2[] = "noise-s2.dat";
   char         outfile1[] = "corrected1.dat";
   char         outfile2[] = "corrected2.dat";

   // read data
   if (!read_Fmat(Fname, F) ||
       !read_data(infile1, &pos0, &Num1) ||
       !read_data(infile2, &pos1, &Num2))
   {
      std::cerr << "Data file open failed!" << std::endl;
      return 1;
   }

   if (Num1 != Num2)
      return 1;
   Num = Num1;

   // alloc
   npos0 = new Vector2d [Num];
   npos1 = new Vector2d [Num];

   theta << F(0,0), F(0,1), F(0,2),
      F(1,0), F(1,1), F(1,2), 
      F(2,0), F(2,1), F(2,2);

   // optimal correction
   flag = Triangulation::optimal_correction(pos0, pos1, Num, theta,
                                            npos0, npos1);
   if (!flag)  return 1;
   std::cerr << "Optimal correction succeded!" << std::endl;

   // corrected position output
   write_data(outfile1, npos0, Num);
   write_data(outfile2, npos1, Num);

   return 0;
}
