#ifndef _UTILES_H_
#define _UTILES_H_

#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>

#include <Eigen/Dense>

using namespace std;
using namespace Eigen;

#define MAXPOINTS 8192

// read 2-D data
bool read_data(char filename[],
               double *x0, double *y0, double *x1, double *y1,
               int *Num);

// read F matrix
bool read_F_matrix(char Fname[], Matrix3d& F);

// output 3-D
bool write_3D_data(char fname[], Vector3d X[], int Num);

// output ply
bool write_ply_data(char filename[], Vector3d X[], int Num,
                    int r, int g, int b);

#endif // _UTILES_H_
