#ifndef _UTILS_H_
#define _UTILS_H_

#include <Eigen/Dense>

using namespace Eigen;

bool read_Hmat(char filename[], Matrix3d& F);

bool read_Hmat(char filename[], Vector9d& theta);


bool read_corresp_data(char *filename,
                       double **x0, double **y0,
                       double **x1, double **y1,
                       int *Num);

bool read_data(char filename[], Vector2d **pos0, int *Num);

bool read_data(char *filename,
               double **x0, double **y0,
               int *Num);

bool write_data(char filename[], Vector2d *pos0, int Num);

// output 3-D
bool write_3D_data(char fname[], Vector3d X[], int Num);

// output ply
bool write_ply_data(char filename[], Vector3d X[], int Num,
                    int r, int g, int b);

#endif // _UTILS_H_
