//
// test function for ellipse analysis
//

#include <iostream>
#include <iomanip>
#include <string>

#include "EllipseAnalysis.h"
#include "utils.h"

using namespace Eigen;
using namespace std;

int main()
{
   double *x, *y;
   int Num;
   char ellipsefile[] = "u.dat";
   Matrix3d Q;
   double fl = 600.0;
   double radius = 300.0;
   double f0 = EllipseAnalysis::Default_f0;

   // read data
   if (!read_Q(ellipsefile, Q))
      return 1;

   cerr << scientific << setprecision(10);
   cerr << "Q = \n" << Q << endl;

   // reconstruct supporting plane of a circle
   Vector3d normal;
   double dist;

   EllipseAnalysis::supporting_plane_reconstruction(Q, radius,
                                                    normal, &dist,
                                                    fl, f0);

   // output 3D infomation of supporting plane
   cout << scientific << setprecision(10);
   cout << "normal of supporting plane = " << normal.transpose() << endl;

   cout << "distance to supporting plane = " << dist << endl;

   // compute projected center of circle
   Vector2d center;
   
   EllipseAnalysis::center_of_circle(Q, normal, center, fl, f0);

   cout << "projected center of circle = " << center.transpose() << endl;

   return 0;
}
