//
// test function for front image of ellipse
//

#include <iostream>
#include <iomanip>
#include <string>
#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>

#include "EllipseAnalysis.h"
#include "utils.h"

using namespace Eigen;
using namespace std;

int main()
{
   double *x, *y;
   int Num;
   char ellipsefile[] = "u.dat";
   Matrix3d Q;
   double fl = 600.0;
   double radius = 300.0;
   double f0 = EllipseAnalysis::Default_f0;

   // load input image
   cv::Mat simg = cv::imread("input.jpg", 1);
   
   // read data
   if (!read_Q(ellipsefile, Q))
      return 1;

   cerr << "Q = \n" << Q << endl;

   // display input image
   cv::namedWindow("input", CV_WINDOW_AUTOSIZE|CV_WINDOW_FREERATIO);
   cv::imshow("input", simg);
   cv::waitKey(0);

   // set output image
   cv::Mat dimg(2*simg.rows, 2*simg.cols, simg.type());

   // convert image to frontal one
   EllipseAnalysis::front_image_of_the_circle(Q, radius, simg, dimg, fl, f0);

   // display output image
   cv::namedWindow("front image", CV_WINDOW_AUTOSIZE|CV_WINDOW_FREERATIO);
   cv::imshow("front image", dimg);

   // wait any key input
   cv::waitKey(0);

   // save output image
   cv::imwrite("output.jpg", dimg);

   return 0;
}
