//
// test function for ellipse analysis
//

#include <iostream>
#include <iomanip>
#include <string>

#include "EllipseAnalysis.h"
#include "utils.h"

using namespace Eigen;
using namespace std;

int main()
{
   char q1file[] = "Q1-theta.dat";
   char q2file[] = "Q2-theta.dat";
   Matrix3d Q1, Q2;
   double f0 = EllipseAnalysis::Default_f0;

   // read 1st Conic data
   if (!read_Q(q1file, Q1))
      return 1;

   // read 2nd Conic data
   if (!read_Q(q2file, Q2))
      return 1;

   cerr << "Q1 = \n" << Q1 << endl;
   cerr << "Q2 = \n" << Q2 << endl;

   // four intersection points
   Vector2d Pa, Pb, Pc, Pd;

   if (!EllipseAnalysis::ellipse_intersections(Q1, Q2, Pa, Pb, Pc, Pd, f0))
   {
      cerr << "failed!" << endl;
      return 1;
   }

   // output intersections
   cout << "Pa = " << Pa.transpose() << endl;
   cout << "Pb = " << Pb.transpose() << endl;
   cout << "Pc = " << Pc.transpose() << endl;
   cout << "Pd = " << Pd.transpose() << endl;

   return 0;
}
