//
// test function for ellipse analysis
//

#include <iostream>
#include <iomanip>
#include <string>

#include "EllipseAnalysis.h"
#include "utils.h"

using namespace Eigen;
using namespace std;

int main()
{
   double *x, *y;
   int Num;
   char ellipsefile[] = "Q1-theta.dat";
   Matrix3d Q;
   double fl = 600.0;
   double f0 = EllipseAnalysis::Default_f0;
   
   Vector2d p1(500.0,0); // point1
   Vector2d p2(0,500.0); // point2
   Vector2d q1, q2;

   // read data
   if (!read_Q(ellipsefile, Q))
      return 1;

   cerr << "Q = \n" << Q << endl << endl;

   // perpendicular to the ellipse
   EllipseAnalysis::perpendicular_to_ellipse(Q, p1, q1, f0);

   // output 3D infomation of supporting plane
   cout << "p1 = " << p1.transpose() << endl;
   cout << "perpendicular to ellipse of p1 = " << q1.transpose() << endl;
   cout << endl;

   EllipseAnalysis::perpendicular_to_ellipse(Q, p2, q2, f0);
   
   cout << "p2 = " << p2.transpose() << endl;
   cout << "perpendicular to ellipse of p2 = " << q2.transpose() << endl;

   return 0;
}
